<template>
  <div>
    <template v-if="isSwitchAllowed">
      <SwProductSelect v-if="selectedOption"
                       :value="selectedOption"
                       :options="productOptions"
                       :label="translatedProperty"
                       @change="onChange"/>
    </template>
    <template v-else>
      <!-- dumb list of properties -->
      <div v-for="option in productOptions" :key="option.code" :value="option.code">
        <div class="sf-component-select sf-select--underlined product-details__attribute is-selected"
             :aria-label="translatedProperty">
          <div style="position: relative;">
            <div v-if="selectedOption === option.code" class="sf-component-select__selected sf-component-select-option">
              <SfProductOption :label="`${option.label}`" :color="option.color"/>
              <div class="sf-component-select__label">
                {{translatedProperty}}
              </div>
            </div>
          </div>
        </div>
      </div>
    </template>
  </div>
</template>

<script lang="ts">
  import { computed, watch, inject, ref } from "@vue/composition-api";
  import { useProductConfigurator, useNotifications, useProduct } from "@shopware-pwa/composables"
  import { getProductUrl, getTranslatedProperty, getProductOptions } from "@shopware-pwa/helpers"
  import { SfProductOption } from "@storefront-ui/vue"

  import { useQuickView } from '../logic/composables/useQuickView';
  import { useDynamicPage } from '../logic/composables/useDynamicPage';
  import { useAppointment } from '../logic/composables/useAppointment';

  export default {
    name: "SwGsProductSelect",
    components: {
      SwProductSelect: () => import("@/components/SwProductSelect.vue"),
      SfProductOption,
    },
    setup(props, { root, attrs }) {
      const { config, product } = attrs.slotContext;

      const { pushInfo } = useNotifications();
      const { handleChange, getSelectedOptions, findVariantForSelectedOptions } = useProductConfigurator({ product });
      const { setQuickViewProduct, isQuickViewProductChanging, setQuickViewLoadingState } = useQuickView();
      const { openDynamicPage } = useDynamicPage();
      const { isGuide, isClient, isSelfService } = useAppointment();
      const productComposable = useProduct();

      const productSearch = {
        search: productComposable.search,
        product: productComposable.product
      };

      const pageType = inject("gs-product-page-type", computed(() => 'pwa-pdp'));

      const translatedProperty = computed(() => getTranslatedProperty(config, 'name'));
      const productOptions = computed(() => getProductOptions({ product: config }));
      const selectedOption = computed(() => getSelectedOptions.value[translatedProperty.value]);
      const changedOption = ref(null);

      const onOptionChanged = (option) => {
        changedOption.value = option;
        return option;
      };

      // get always the newest options - getSelectedOptions is obsolete for a moment - this is why watch is used
      watch(getSelectedOptions, async (options: any) => {
        // look for variant with the selected options and perform a redirect to the found product's URL
        const foundVariant = await findVariantForSelectedOptions(options);
        if (foundVariant !== null) return switchPage(foundVariant);

        // if no variant was found - reset other options and try to find a first matching product
        const foundSimpleVariant = await findVariantForSelectedOptions({ option: changedOption.value });
        if (foundSimpleVariant !== null) return switchPage(foundSimpleVariant);

        pushInfo(root.$t("There is no available product for selected options"))
      });

      const switchPage = async (variant) => {
        if (pageType.value === 'pwa-pdp') {
          root.$router.push(root.$routing.getUrl(getProductUrl(variant)));
          return;
        } else if (pageType.value === 'dynamic-page' || pageType.value === 'cms-page') {
          openDynamicPage({
            type: 'product',
            opened: true,
            productId: variant.id,
          });
        } else if (pageType.value === 'quickView') {
          const changing = isQuickViewProductChanging(variant);
          if (!changing) return;
          setQuickViewLoadingState(changing);
          await productSearch.search(variant.id);
          setQuickViewProduct(productSearch.product.value);
          return;
        }
      };

      const onChange = ($event) => {
        handleChange(translatedProperty.value, $event, onOptionChanged($event));
      };

      return {
        config,
        productOptions,
        product,
        selectedOption,
        translatedProperty,
        onChange,
        isSwitchAllowed: computed(() => isGuide.value || isSelfService.value || pageType.value === 'quickView')
      };
    },
  }
</script>
